<?php 

	class Icegram_Connector_v_0_1 {

		var $base_name;
	    var $check_update_timeout;
	    var $last_checked;
	    var $plugin_data;
	    var $sku;
	    var $installed_version;
	    var $live_version;
	    var $slug;
	    var $name;
	    var $documentation_link;
	    var $prefix;
	    var $text_domain;

		function __construct( $file, $sku='', $prefix, $plugin_name, $text_domain, $documentation_link ){
			if (! function_exists( 'get_plugin_data' )) {
	            require_once ABSPATH . 'wp-admin/includes/plugin.php';
	        }
			$this->plugin_data          = get_plugin_data( $file );
	        $this->base_name            = plugin_basename( $file );
	        $this->slug                 = dirname( $this->base_name );
	        $this->name                 = $plugin_name;
	        $this->sku                  = $sku;
	        $this->documentation_link   = $documentation_link;
	        $this->prefix               = $prefix;
	        $this->text_domain          = $text_domain;
			// $this->client_id = 'pclmX42WIYvaBOeUzuExHsCf0iHh2HKEA3wff0KZ';
	        $this->client_id = 'KoP4P8aRMuMVoiqGxO904Dcx3BzBDXRnmHrbPC2C';
	        // $this->client_secret = 'dVUzMUJKYBdi7AVrr4gV6duN12lR17ztOA98HkIS';
	        $this->client_secret = '6Pxv8XbGMlGQYTo1uYD8VvwhcYs1BvEHlbdt9o9V';
	         // IG storeconnector
	        add_action( 'admin_notices', array( $this, 'connect_icegram_notification' ) );
	        add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts_styles' ) );
	        add_action( 'wp_ajax_'.$this->prefix.'_get_authorization_code', array( $this, 'get_authorization_code' ) );
	        add_action( 'wp_ajax_'.$this->prefix.'_disconnect_icegram', array( $this, 'disconnect_icegram' ) );
	        add_action( 'admin_footer', array( $this, 'add_plugin_style_script' ) );
	        if ( has_action( 'wp_ajax_get_icegram_updates', array( $this, 'get_icegram_updates' ) ) === false ) {
	            add_action( 'wp_ajax_get_icegram_updates', array( $this, 'get_icegram_updates' ) );
	        }

		}

		// IG storeconnector
        function enqueue_scripts_styles() {
            if ( ! wp_script_is( 'jquery' ) ) {
                wp_enqueue_script( 'jquery' );
            }
            
            add_thickbox();
        }

        function connect_icegram_notification() {
            if ( did_action( 'connect_icegram_org_notification' ) > 0 ) {
                return;
            }

            
            global $wpdb, $pagenow;

            $ig_is_page_for_notifications = apply_filters( 'ig_is_page_for_notifications', false, $this );
            
            if ( $ig_is_page_for_notifications || $pagenow == 'plugins.php' ) {
                

                ?>
                <script type="text/javascript">
                    jQuery(function(){
                        jQuery(window).on('load', function(){
                            var has_class = jQuery('body').hasClass('plugins-php');
                            if ( ! has_class ) {
                                jQuery('body').addClass('plugins-php');
                            }
                        });
                    });
                </script>
                <?php

                $license_key  = $wpdb->get_var( "SELECT option_value FROM {$wpdb->options} WHERE option_name LIKE '%_license_key%' AND option_value != '' LIMIT 1" );
                $access_token = get_option( '_icegram_connector_access_token' );
                $token_expiry = get_option( '_icegram_connector_token_expiry' );
                $is_connected = get_option( '_icegram_connected', 'no' );
                // $auto_connect = get_option( '_icegram_auto_connected', 'no' );

                $protocol = 'http';

                $url = $protocol . "://www.icegram.stg/oauth/authorize?response_type=code&client_id=" . $this->client_id . "&redirect_uri=" . add_query_arg( array( 'action' => $this->prefix . '_get_authorization_code' ), admin_url( 'admin-ajax.php' ) );

                if ( empty( $token_expiry ) || time() > $token_expiry ) {
                    
                    ?>
                    <div id="connect_icegram_org" style="display: none;">
                        <div style="width: 96% !important; height: 96% !important;" class="connect_icegram_child">
                            <div id="connect_icegram_org_step_1" style="background: #FFEAD4;
                                                                            box-shadow: 0 0 1px rgba(0,0,0,.2);
                                                                            padding: 20px;
                                                                            position: absolute;
                                                                            top: 50%;
                                                                            left: 50%;
                                                                            transform: translate(-50%, -50%);
                                                                            width: inherit;
                                                                            height: inherit;">
                                <center>
                                    <img class="icegram-logo" src="https://www.icegram.stg/wp-content/uploads/2014/05/cropped-icegram-logo-16bit-300x70.png" alt="icegram.stg" />
                                    <h2><?php echo __( 'You are one step away from completing activation.', $this->text_domain ); ?></h2>
                                    <button class="icegram-connect-flat-button"><?php echo __( 'Connect to icegram.stg', $this->text_domain ); ?></button>
                                    <h3><?php echo __( 'You get', $this->text_domain ); ?></h3>
                                    <div>
                                        <ol>
                                            <li><span class="dashicons dashicons-yes"></span><?php echo __( 'Automatic license validation', $this->text_domain ); ?></li>
                                            <li><span class="dashicons dashicons-yes"></span><?php echo __( 'Freedom from manual plugin updates', $this->text_domain ); ?></li>
                                            <li><span class="dashicons dashicons-yes"></span><?php echo __( 'Instant notification about critical updates & security releases', $this->text_domain ); ?></li>
                                        </ol>
                                    </div>
                                </center>
                            </div>
                            <div id="connect_icegram_org_step_2" style="display: none; width: 100%; height: 100%;">
                                <iframe src="" style="width: 100%; height: 100%;"></iframe>
                            </div>
                            <style type="text/css" media="screen">
                                #TB_window{
                                  height:550px !important;
                                  width:600px !important;
                                }
                                #TB_ajaxContent {
                                    position: relative;
                                    width: 96% !important;
                                }
                                .connect_icegram_child {
                                    position: absolute;
                                    top: 50%;
                                    left: 50%;
                                    transform: translate(-50%, -50%);
                                }
                                #connect_icegram_org_step_1 .dashicons-yes {
                                    color: #27ae60;
                                    font-size: 2.2em;
                                    margin-right: 5px;
                                    vertical-align: text-bottom;
                                }
                                #connect_icegram_org_step_1 a {
                                    display: inline-block;
                                    cursor: pointer;
                                    margin: 1.5em 0;
                                    text-decoration: underline;
                                }
                                #connect_icegram_org_step_1 ol {
                                    width: auto;
                                    margin: auto;
                                    display: inline-block;
                                    list-style: none;
                                }
                                #connect_icegram_org_step_1 ol li {
                                    text-align: left;
                                }
                                #connect_icegram_org_step_1 .icegram-logo,
                                #connect_icegram_org_step_1 button {
                                    margin: 1.5em 0;
                                }
                                #connect_icegram_org_step_1 .icegram-connect-flat-button {
                                    position: relative;
                                    vertical-align: top;
                                    height: 2.8em;
                                    padding: 0 2.5em;
                                    font-size: 1.5em;
                                    color: white;
                                    text-align: center;
                                    text-shadow: 0 1px 2px rgba(0, 0, 0, 0.25);
                                    background: #27ae60;
                                    border: 0;
                                    border-radius: 5px;
                                    border-bottom: 2px solid #219d55;
                                    cursor: pointer;
                                    -webkit-box-shadow: inset 0 -2px #219d55;
                                    box-shadow: inset 0 -2px #219d55;
                                }
                                #connect_icegram_org_step_1 .icegram-connect-flat-button:active {
                                    top: 1px;
                                    outline: none;
                                    -webkit-box-shadow: none;
                                    box-shadow: none;
                                }
                            </style>
                            <script type="text/javascript">
                                var jQuery = parent.jQuery;
                                jQuery('#connect_icegram_org_step_1').on('click', 'button,a', function(){
                                    jQuery('#connect_icegram_org_step_2 iframe').attr('src', '<?php echo $url; ?>');
                                    jQuery('#connect_icegram_org_step_1').fadeOut();
                                    jQuery('#connect_icegram_org_step_2').fadeIn();
                                });
                            </script>
                        </div>
                    </div>
                    <?php
                }

                if ( $is_connected === 'yes'  ) {
                    ?>
                    <style type="text/css" media="screen">
                        #connect_icegram_org_response {
                            display: block !important;
                        }
                        #connect_icegram_org_response h2 {
                            font-size: 1.3em !important;
                            font-weight: 600 !important;
                            margin: 15px 0 !important;
                        }
                        #connect_icegram_org_response span.dashicons-yes {
                            margin: -8px 10px 0 0;
                            display: inline-block;
                        }
                    </style>
                    <div id="connect_icegram_org_response" class="updated fade success">
                        <center><h2><span class="dashicons dashicons-yes" style="font-size: 2em; color: #46b450;"></span>&nbsp;<?php echo __( 'Congrats! Activation Completed', $this->text_domain ); ?></h2></center>
                    </div>
                    <?php
                    //TODO :: check this account connection
                    update_option( '_icegram_connected', 'no' );
                }
            }
            do_action( 'connect_icegram_org_notification' );
        }

        function get_authorization_code() {
            if ( empty( $_REQUEST['code'] ) ) {
                die(__( 'Code not received', $this->text_domain ) );
            }
            $args = array( 
                        'grant_type' => 'authorization_code', 
                        'code' => $_REQUEST['code'], 
                        'redirect_uri' => add_query_arg( array( 'action' => $this->prefix . '_get_authorization_code' ), admin_url( 'admin-ajax.php' ) ) 
                    );
            $this->get_tokens( $args );
            ?>
            <script type="text/javascript">
                parent.tb_remove();
                parent.location.reload( true );
            </script>
            <?php
            die();
        }

        function get_tokens( $args = array() ) {

            if ( empty( $args ) ) {
                return;
            }

            $protocol = 'http';

            $url = $protocol . '://www.icegram.stg/oauth/token';
            $response = wp_remote_post( $url, 
                                        array( 
                                            'headers' => array(
                                                            'Authorization' => 'Basic ' . base64_encode( $this->client_id . ':' . $this->client_secret ),
                                                        ),
                                            'body' => $args, 
                                        )
                                    );
            if ( ! is_wp_error( $response ) ) {
                $code = wp_remote_retrieve_response_code( $response );
                $message = wp_remote_retrieve_response_message( $response );

                if ( $code = 200 && $message = 'OK' ) {
                    $body = wp_remote_retrieve_body( $response );
                    $tokens = json_decode( $body );
                   
                    if ( ! empty( $tokens ) ) {
                        $present = time();
                        $offset = ( ! empty( $tokens->expires_in ) ) ? $tokens->expires_in : 0;
                        $access_token = ( ! empty( $tokens->access_token ) ) ? $tokens->access_token : '';
                        $token_expiry = ( ! empty( $offset ) ) ? $present + $offset : $present;
                        if ( ! empty( $access_token ) ) {
                            update_option( '_icegram_connector_access_token', $access_token );
                            update_option( '_icegram_connected', 'yes' );
                        }
                        if ( ! empty( $token_expiry ) ) {
                  
                            update_option( '_icegram_connector_token_expiry', $token_expiry );
                        }
                    }
                }
            }

        }

        function get_icegram_updates() {

            check_ajax_referer( 'icegram-update', 'security' );

            if ( empty( $this->last_checked ) ) {
                $icegram_data = $this->get_icegram_data();
                $this->last_checked = ( ! empty( $icegram_data['last_checked'] ) ) ? $icegram_data['last_checked'] : null;
                if ( empty( $this->last_checked ) ) {
                    $this->last_checked = strtotime( '-1435 minutes' );
                    $icegram_data['last_checked'] = $this->last_checked;
                    error_log(print_r($icegram_data, true));
                    $this->set_icegram_data( $icegram_data );
                }
            }

            $time_not_changed = isset( $this->last_checked ) && $this->check_update_timeout > ( time() - $this->last_checked );

            if ( ! $time_not_changed ) {
            // if ( true ) {
                $this->request_icegram_data();
            }

            wp_send_json( array( 'success' => 'yes' ) );

        }

        function request_icegram_data() {
            $data = array();
            $icegram_deactivated_plugins = array();
            $icegram_activated_plugins = array();
            $icegram_connector_data = get_option('_icegram_connector_data');
            $access_token = get_option( '_icegram_connector_access_token' );
            if ( empty( $access_token ) ) {
                return;
            }
            if ( ! function_exists( 'get_plugins' ) ) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }
            $all_plugins = get_plugins();
            $all_activated_plugins = get_option( 'active_plugins' );
            foreach ( $all_plugins as $plugin_file => $plugin_data ) {
                $author = ( ! empty( $plugin_data['Author'] ) ) ? strtolower( $plugin_data['Author'] ) : null;
                $version = ( ! empty( $plugin_data['Version'] ) ) ? $plugin_data['Version'] : '';
                if ( empty( $author ) ) {
                    continue;
                }
                if ( in_array( $author, array( 'icegram' ) ) ) {
                    if ( in_array( $plugin_file, $all_activated_plugins ) ) {
                        $icegram_activated_plugins[ $plugin_file ] = $version;
                    } else {
                        $icegram_deactivated_plugins[ $plugin_file ] = $version;
                    }
                }
            }
            //Check update code merge
            $this->live_version         = get_site_option( $this->prefix.'_live_version' );
            $this->installed_version    = get_site_option( $this->prefix.'_installed_version' );
            if (version_compare( $this->installed_version, $this->live_version, '<=' )) {

                $protocol = 'http';
                // $url = $protocol . '://www.icegram.stg/wp-json/woocommerce-serial-key/v1/serial-keys';
                $url = $protocol . '://www.icegram.stg/wp-admin/admin-ajax.php?action=get_access_data';
                $args = array(
                            'plugins' => array(
                                                'activated' => $icegram_activated_plugins,
                                                'deactivated' => $icegram_deactivated_plugins
                                            ),
                            'sku' => $this->sku
                        );
                $response = wp_remote_get( $url, 
                                            array( 
                                                'headers' => array(
                                                                'Authorization' => 'Bearer ' . $access_token,
                                                                'Referer' => base64_encode( $this->sku . ':' . $this->installed_version . ':' . $this->client_id . ':' . $this->client_secret )
                                                            ),
                                                'body' => $args, 
                                            )
                                        );

                if ( ! is_wp_error( $response ) ) {
                    $code = wp_remote_retrieve_response_code( $response );
                    $message = wp_remote_retrieve_response_message( $response );

                    if ( $code = 200 && $message = 'OK' ) {
                        $body = wp_remote_retrieve_body( $response );
                        $response_data = json_decode( $body, true );
                        if ( ! empty( $response_data['downloads'] ) ) {
                            // $response_data['skus']['last_checked'] = time();
                            foreach ($response_data['downloads'] as $sku => $download) {
                                $live_version   = $download['version'];
                                $download_url   = add_query_arg( 'version', $live_version, $download['download_url'] );
                                update_site_option( $this->prefix.'_download_url', $download_url );
                                update_site_option( $this->prefix.'_live_version', $live_version );
                            }
                            $this->set_icegram_data( $response_data );
                        }
                    }
                }
            }
            //
        }

        function disconnect_icegram() {

            check_ajax_referer( 'disconnect-icegram', 'security' );

            delete_option( '_icegram_connector_data' );
            delete_option( '_icegram_connector_access_token' );
            delete_option( '_icegram_connector_token_expiry' );
            delete_option( '_icegram_connected' );
            // delete_option( '_icegram_auto_connected' );

            echo json_encode( array( 'success' => 'yes', 'message' => 'success' ) );

            die();

        }

        public function get_icegram_data() {

            $data = get_option( '_icegram_connector_data', array() );

            $update = false;

            if ( empty( $data[ $this->sku ] ) ) {
                $data[ $this->sku ] = array(
                                            'installed_version'         => '0',
                                            'live_version'              => '0',
                                            'license_key'               => '',
                                            'changelog'                 => '',
                                            'due_date'                  => '',
                                            'download_url'              => '',
                                            'next_update_check'         => false,
                                            'upgrade_notices'           => array(),
                                            'saved_changes'             => 'no',
                                            'hide_renewal_notification' => 'no',
                                            'hide_license_notification' => 'no'
                                        );
                $update = true;
            }

            if ( empty( $data['last_checked'] ) ) {
                $data['last_checked'] = 0;
                $update = true;
            }

            if ( empty( $data['login_link'] ) ) {
                $protocol = 'http';
                $data['login_link'] = $protocol . '://www.icegram.stg/my-account';
                $update = true;
            }

            if ( $update ) {
                update_option( '_icegram_connector_data', $data );
            }

            return $data;

        }

        public function set_icegram_data( $data = array(), $force = false ) {
            error_log(print_r($data, true));
            if ( $force || ! empty( $data ) ) {
                update_option( '_icegram_connector_data', $data );
            }

        }

        function add_plugin_style_script() {

            global $pagenow;

            $this->add_plugin_style();
            ?>
                
                <script type="text/javascript">
                        jQuery(function(){
                            jQuery('a#<?php echo $this->prefix; ?>_disconnect_icegram').on( 'click', function(){
                                var trigger_element = jQuery(this);
                                var status_element = jQuery(this).closest('tr');
                                status_element.css('opacity', '0.4');
                                jQuery.ajax({
                                    url: '<?php echo admin_url("admin-ajax.php") ?>',
                                    type: 'post',
                                    dataType: 'json',
                                    data: {
                                        action: '<?php echo $this->prefix; ?>_disconnect_icegram',
                                        prefix: '<?php echo $this->prefix; ?>',
                                        security: '<?php echo wp_create_nonce( "disconnect-icegram" ); ?>'
                                    },
                                    success: function( response ) {
                                        status_element.css('opacity', '1');
                                        trigger_element.text('<?php echo __( 'Disconnected', $this->text_domain ); ?>');
                                        trigger_element.css({
                                            'background-color': '#46b450',
                                            'color': 'white'
                                        });
                                        setTimeout( function(){
                                            location.reload();
                                        }, 1500);
                                    }
                                });
                            });
                            // jQuery(window).on('load', function(){
                            //     jQuery.ajax({
                            //         url: '<?php echo admin_url( "admin-ajax.php" ); ?>',
                            //         type: 'POST',
                            //         dataType: 'json',
                            //         data: {
                            //             'action': 'get_icegram_updates',
                            //             'security': '<?php echo wp_create_nonce( 'icegram-update' ); ?>'
                            //         },
                            //         success: function( response ) {
                            //             if ( response != undefined && response != '' ) {
                            //                 if ( response.success != 'yes' ) {
                            //                     console.log('<?php echo sprintf(__( "Error at %s", $this->text_domain ), plugin_basename( __FILE__ ) . ':' . __LINE__ ); ?>', response);
                            //                 }
                            //             }
                            //         }
                            //     });
                                
                            // });
                            jQuery(window).on('load', function(){
                                var iframe_content = jQuery('#connect_icegram_org_div').text();
                                iframe_content = ( iframe_content != undefined ) ? iframe_content.trim() : iframe_content;
                                var div_content = jQuery('#connect_icegram_org').html();
                                var is_iframe_empty = iframe_content == undefined || iframe_content == '';
                                var is_div_empty = div_content == undefined || div_content == '';
                                if ( iframe_content == 'no_user' || ( is_iframe_empty && ! is_div_empty ) ) {
                                    <?php if ( $pagenow != 'plugins.php' ) { ?>
                                            console.log(0000);

                                            // tb_show('', "#TB_inline?inlineId=connect_icegram_org&height=550&width=600");
                                    <?php } ?>
                                }
                            });

                        });
                </script>
            <?php
        }

        function add_plugin_style() {
                ?>
                <style type="text/css">
                    div#TB_ajaxContent {
                        overflow: hidden;
                        position: initial;
                    }
                    <?php if ( version_compare( get_bloginfo( 'version' ), '3.7.1', '>' ) ) { ?>
                    tr.<?php echo $this->prefix; ?>_license_key .key-icon-column:before {
                        content: "\f112";
                        display: inline-block;
                        -webkit-font-smoothing: antialiased;
                        font: normal 1.5em/1 'dashicons';
                    }
                    tr.<?php echo $this->prefix; ?>_due_date .renew-icon-column:before {
                        content: "\f463";
                        display: inline-block;
                        -webkit-font-smoothing: antialiased;
                        font: normal 1.5em/1 'dashicons';
                    }
                    <?php } ?>
                    a#<?php echo $this->prefix; ?>_reset_license,
                    a#<?php echo $this->prefix; ?>_disconnect_icegram {
                        cursor: pointer;
                    }
                    a#<?php echo $this->prefix; ?>_disconnect_icegram:hover {
                        color: #fff;
                        background-color: #dc3232;
                    }
                    span#<?php echo $this->prefix; ?>_hide_renewal_notification,
                    span#<?php echo $this->prefix; ?>_hide_license_notification {
                        cursor: pointer;
                        float: right;
                        opacity: 0.2;
                    }
                </style>
                <?php
        }

    }



?>